#include <stdio.h>
#include <tchar.h>
#include "../pdfx64_dll/pdffuncs.h"

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 
#include <math.h>

#pragma comment( lib, "../../bin/pdfx64.lib" )

//define for VerySetFunction
#define Very_Set_MultiPage		101
#define Very_Set_ImagePosAndSize	104
#define Very_Set_Encrypt 		105
#define Very_Set_Font			106
#define Very_Set_NewOrClosePage		109
#define Very_Set_BookMark		110
#define Very_Set_ViewerPreferences	121
#define Very_Set_PageOrientation	122
#define Very_Set_Line_Dash		123
#define Very_Set_Line_Flat		124
#define Very_Set_Line_Join		125
#define Very_Set_Line_Cap		126
#define Very_Set_Line_MiterLimit	127

#define Very_Set_Link_BorderStyle	128
#define Very_Set_Link_BorderDash	129
#define Very_Set_Link_Web		130
#define Very_Set_Link_Local		132

#define Very_Set_Text_Matrix		133
#define Very_Set_Text_Leading		134
#define Very_Set_Text_Rise		135
#define Very_Set_Text_HorizScaling	136
#define Very_Set_Text_Rendering		137
#define Very_Set_Text_CharSpace		138
#define Very_Set_Text_WordSpace		139
#define Very_Set_Range			131

//define for VeryGetFunction
#define Very_Get_ImagePageCount		201
#define Very_Get_ImageSizeW		202
#define Very_Get_ImageSizeH		203
#define Very_Get_ImageDpiX		204
#define Very_Get_ImageDpiY		205
#define Very_Get_PdfPageCount		206
#define Very_Get_PdfCurrentPageSize	209
#define Very_Get_StringWidth		250
#define Very_Get_StringHeight		251
#define Very_Get_PageBoxForStamp	260

//define for VeryAddText
#define Very_DT_LEFT			0
#define Very_DT_CENTER			1
#define Very_DT_RIGHT			2
#define Very_DT_WORDBREAK		0x10
#define Very_DT_CALCRECT		0x400

BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();


char *GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
	return out_path;
}

void AddImageFile(long id, char *lpszImageFile)
{
	long width,height,xdpi,ydpi;
	char szImageFile[256];

	//add bookmark
	VerySetFunction(id,Very_Set_BookMark,0,0,"bookmark two",0);
	int pagenum=VeryGetFunction(id,Very_Get_ImagePageCount,0,0,lpszImageFile,0);
	for(int i = 1; i <= pagenum; i++)
	{
		char buf[32];
		char buf2[32];
		long iret;
		width = VeryGetFunction(id,Very_Get_ImageSizeW,0,0,lpszImageFile,ltoa(i,buf,10));
		height = VeryGetFunction(id,Very_Get_ImageSizeH,0,0,lpszImageFile,ltoa(i,buf,10));
		//Get image dpi (Resolution)
		xdpi=VeryGetFunction(id,Very_Get_ImageDpiX,0,0,lpszImageFile,ltoa(i,buf,10));
		ydpi=VeryGetFunction(id,Very_Get_ImageDpiX,0,0,lpszImageFile,ltoa(i,buf,10));
		if(xdpi>0&&ydpi>0){
			width  = (long)(width * (72.0/xdpi));
			height = (long)(height* (72.0/ydpi));
		}
		//new page
		iret=VerySetFunction(id,Very_Set_NewOrClosePage,width,height,0,0);
		//set image size
		iret=VerySetFunction(id,Very_Set_ImagePosAndSize,0,0,ltoa(width,buf,10),ltoa(height,buf2,10));
		//add image one
		iret=VerySetFunction(id,Very_Set_MultiPage,i,1,0,0);
		iret=VeryAddImage(id,lpszImageFile);
		//close the page
		iret=VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
	}
}

int main(int argc, _TCHAR* argv[])
{
	VeryInitializeLibrary();
	
	VeryStampReg("XXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

	char szTempBuffer[4096] = {0};
	int id=VeryCreate(GetModulePath(szTempBuffer, "_out.pdf"));
	if(id>0)
	{
		VeryAddInfo(id,"Title","Subject","Author","Keywords","Creator");
		VerySetFunction(id,Very_Set_ViewerPreferences,4+4096,2,0,0);

		AddImageFile(id, GetModulePath(szTempBuffer, "case49131PART1.SLDDRW.Sheet1.TIF"));
		AddImageFile(id, GetModulePath(szTempBuffer, "case49131PART1.SLDDRW.Sheet2.TIF"));
		AddImageFile(id, GetModulePath(szTempBuffer, "case49131PART1.SLDDRW.Sheet3.TIF"));
		
		VeryClose(id);
	}

	VeryUninitializeLibrary();
	return 0;
}

